Subject: Re: [PATCH net-next v2 6/9] selftests: drv-net: gro: use SO_TXTIME to schedule packets together

From: Jakub Kicinski <[email-masked]>
Date: Tue, 10 Feb 2026 19:48:14 -0800

On Tue, 10 Feb 2026 22:15:25 -0500 Willem de Bruijn wrote:
> > It's a bit of an opportunistic optimization.
> > 
> > I initially intended it for for the "long sequence of packets"
> > test. But I failed to get AF_PACKET+FQ to cooperate sufficiently
> > to queue all of the packets in the same bucket. Otherwise FQ "sorts"
> > the packets, and breaks what the test is trying to do :(  
> 
> I wonder what's going wrong here.
> 
> fq_classify should pick the queue based on skb->sk also for packet
> sockets.
> 
> And flow_queue_add should add the packets to the tail of the linear
> list if the delivery time is identical to that of the tail.

It works but requires that we either modify the qdisc config to set
a orphan_mask of 1, or somehow set the skb->hash on the AF_PACKET skbs.
The test sends out multiple flows (src ports) so if we let fq compute
the real hash we end up in different buckets.